#include <limits.h>
#include "libm.h"
#if LD64
int ilogbl(long double x)
{
	return ilogb(x);
}
#elif LD80
int ilogbl(long double x)
{
	union ldshape u = {x};
	uint64_t m = u.bits.m;
	int e = u.bits.exp;

	if (!e) {
		if (m == 0)
			return FP_ILOGB0;
		/* subnormal x */
		for (e = -0x3fff+1; m < (uint64_t)1<<63; e--, m<<=1);
		return e;
	}
	if (e == 0x7fff)
		/* in ld80 msb is set in inf */
		return m & ~((uint64_t)1<<63) ? FP_ILOGBNAN : INT_MAX;
	return e - 0x3fff;
}
#endif
